/*******************************************************************************
 * FoxWeapon_FlameThrowerBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_FlameThrowerBase extends FoxWeapon_AutomaticRifleBase
    native(Weapon)
    config(Weapon)
    hidecategories(Navigation);

var float FlameExtent;
var(Sockets) const name ActionSocketName;
var const config float timeToMaxFlameLength;
var private bool bshouldCalcFiring;
var bool bIsFlameImpacting;
var AkEvent FlameStarterStartEvent;
var AkEvent FlameStarterStopEvent;
var private float flameGrowthTime;
var private float flameLength;
var config float maxImpactFXDistance;
var private Vector worldImpactLocation;
var export editinline MaterialInstanceConstant flameTrailMat;

// Export UFoxWeapon_FlameThrowerBase::execCalcAndSetFlameParms(FFrame&, void* const)
native simulated function CalcAndSetFlameParms(float DeltaSeconds);

simulated function ParticleSystem GetWeaponSpecificImpactEffect(FoxPMPInfo_ImpactFX ImpactFX_Info, const byte FiringMode)
{
    return ImpactFX_Info.FlameImpactFX;
    //return ReturnValue;    
}

simulated function AkEvent GetWeaponSpecificImpactSound(FoxPMPInfo_ImpactFX ImpactFX_Info, const byte FiringMode)
{
    return ImpactFX_Info.FlameImpactSound;
    //return ReturnValue;    
}

simulated event SetFlameParameters(float flameMaxDistance, float flameDip, float flameDistance)
{
    // End:0x40
    if(FlameEmitter != none)
    {
        FlameEmitter.SetFloatParameter('Length', flameDistance);
    }
    flameTrailMat.SetScalarParameterValue('FlameThrower_Dip', 0.0);
    flameTrailMat.SetScalarParameterValue('FlameThrower_X', flameDistance);
    //return;    
}

protected simulated function AttachMuzzleEffectsComponents(SkeletalMeshComponent SkelMesh)
{
    // End:0xF5
    if((((((((WorldInfo.NetMode == NM_DedicatedServer) || MuzzleSocketName == 'None') || ActionSocketName == 'None') || SkelMesh == none) || FoxPawn(Instigator) == none) || FoxPawn(Instigator).IsInjured()) || !IsWeapon() && IsFirstPerson()) || (IsWeapon()) && !IsFirstPerson())
    {
        return;
    }
    // End:0x277
    if((MuzFlashEmitter != none) && !SkelMesh.IsComponentAttached(MuzFlashEmitter))
    {
        SkelMesh.AttachComponentToSocket(MuzFlashEmitter, ActionSocketName);
        StartFlameStarterEffect();
        // End:0x207
        if((MuzzleFlashLight != none) && !SkelMesh.IsComponentAttached(MuzzleFlashLight))
        {
            MuzzleFlashLight.SetTranslation(MuzzleLightOffsetFromCannon);
            SkelMesh.AttachComponentToSocket(MuzzleFlashLight, ActionSocketName);
        }
        // End:0x277
        if((FlameStarterStopper != none) && !SkelMesh.IsComponentAttached(FlameStarterStopper))
        {
            SkelMesh.AttachComponentToSocket(FlameStarterStopper, ActionSocketName);
        }
    }
    // End:0x2E7
    if((FlameEmitter != none) && !SkelMesh.IsComponentAttached(FlameEmitter))
    {
        SkelMesh.AttachComponentToSocket(FlameEmitter, MuzzleSocketName);
    }
    //return;    
}

simulated function StartFlameStarterEffect()
{
    // End:0x273
    if(IsMuzzleFlashRelevant())
    {
        // End:0x161
        if(ShouldShowMuzzleFlash())
        {
            // End:0x111
            if(MuzFlashEmitter != none)
            {
                MuzFlashEmitter.SetHidden(false);
                MuzFlashEmitter.SetLODLevel(FoxGRI(WorldInfo.GRI).GetLODLevelToUse(MuzFlashEmitter.Template, GetMuzzleLoc()));
                MuzFlashEmitter.SetActive(true);
                // End:0x111
                if(FlameStarterStartEvent != none)
                {
                    PostAkEvent(FlameStarterStartEvent);
                }
            }
            // End:0x161
            if(FlameStarterStopper != none)
            {
                FlameStarterStopper.SetHidden(true);
                FlameStarterStopper.SetActive(false);
            }
        }
        // End:0x273
        if((((MuzzleFlashLight != none) && FoxGRI(WorldInfo.GRI) != none) && !FoxGRI(WorldInfo.GRI).ShouldDisableEffectsDueToFramerate(Instigator)) && !bLoopMuzzleFlashLight || !MuzzleFlashLight.bEnabled)
        {
            MuzzleFlashLight.CastDynamicShadows = false;
            MuzzleFlashLight.SetEnabled(true);
            MuzzleLightPulseTime = 0.0;
        }
    }
    //return;    
}

simulated function HideMuzzleFlashEmitter()
{
    //return;    
}

simulated function StartMuzzleFlashEffect()
{
    // End:0x11C
    if((IsMuzzleFlashRelevant()) && !bshouldCalcFiring)
    {
        flameGrowthTime = 0.0;
        flameLength = 0.0;
        bshouldCalcFiring = true;
        // End:0x11C
        if(FlameEmitter != none)
        {
            FlameEmitter.SetHidden(false);
            FlameEmitter.SetLODLevel(FoxGRI(WorldInfo.GRI).GetLODLevelToUse(FlameEmitter.Template, GetMuzzleLoc()));
            FlameEmitter.SetActive(true);
        }
    }
    StartFireRumble();
    //return;    
}

simulated function StopMuzzleFlashEffect()
{
    flameGrowthTime = 0.0;
    flameLength = 0.0;
    bshouldCalcFiring = false;
    // End:0x9E
    if((FlameEmitter != none) && WorldInfo.NetMode != NM_DedicatedServer)
    {
        FlameEmitter.SetActive(false);
        SetFlameParameters(0.0, 0.0, 0.0);
    }
    //return;    
}

simulated function StopFlameStarterEffect()
{
    // End:0x110
    if(IsMuzzleFlashRelevant())
    {
        // End:0x80
        if(MuzFlashEmitter != none)
        {
            MuzFlashEmitter.SetHidden(true);
            MuzFlashEmitter.SetActive(false);
            // End:0x80
            if(FlameStarterStopEvent != none)
            {
                PostAkEvent(FlameStarterStopEvent);
            }
        }
        // End:0xC0
        if(!bLoopMuzzleFlashLight && MuzzleFlashLight != none)
        {
            MuzzleFlashLight.SetEnabled(false);
        }
        // End:0x110
        if(FlameStarterStopper != none)
        {
            FlameStarterStopper.SetHidden(false);
            FlameStarterStopper.SetActive(true);
        }
    }
    //return;    
}

simulated function bool IsMuzzleFlashRelevant()
{
    // End:0x24
    if(Instigator.IsBeingFPSpectatedByLocalController())
    {
        return true;
    }
    // End:0x6F
    if(((Role == ROLE_Authority) && !Instigator.IsLocallyControlled()) && IsWeapon())
    {
        return false;
    }
    return true;
    //return ReturnValue;    
}

simulated function StartReloadAnim(optional byte FireMode)
{
    super(FoxWeapon).StartReloadAnim();
    StopFlameStarterEffect();
    //return;    
}

simulated function StopReloadAnim()
{
    super(FoxWeapon).StopReloadAnim();
    StartFlameStarterEffect();
    //return;    
}

simulated function float StartWeaponPutDownAnim()
{
    StopFlameStarterEffect();
    return super(FoxWeapon).StartWeaponPutDownAnim();
    //return ReturnValue;    
}

simulated function float StartWeaponEquipAnim()
{
    StartFlameStarterEffect();
    return super(FoxWeapon).StartWeaponEquipAnim();
    //return ReturnValue;    
}

simulated event bool IsInstantFire(optional byte FireModeNum)
{
    return true;
    //return ReturnValue;    
}

simulated function StopEffectsForWeaponDrop()
{
    StopFlameStarterEffect();
    //return;    
}

simulated function CustomFire()
{
    local Vector StartTrace;
    local Rotator BaseRotation;
    local Vector EndTrace;
    local float furthestPawnDist;
    local array<WeaponImpactInfo> ImpactInfoArray;
    local FoxPawn aPawn;
    local TraceHitInfo HitInfo;
    local int I;
    local FlashLocData FlashLoc;

    StartTrace = Instigator.GetWeaponStartTraceLocation();
    BaseRotation = GetAdjustedAim(StartTrace);
    EndTrace = StartTrace + (vector(BaseRotation) * flameLength);
    // End:0xA2
    if(bDebug)
    {
        DrawDebugLine(StartTrace, EndTrace, 255, 0, 0, true);
    }
    // End:0x643
    if(Role == ROLE_Authority)
    {
        // End:0x173
        if(bIsFlameImpacting)
        {
            CalcAndSetFlameParms(0.0);
            // End:0x160
            if(WorldInfo.GRI.bClientSideHitDetection)
            {
                FlashLoc.Location = worldImpactLocation;
                FoxPawn(Instigator).ClientSetFlashLocation(FlashLoc);
            }
            SetFlashLocation(worldImpactLocation);
        }
        ImpactInfoArray = GetCollidingPawns(StartTrace, EndTrace, FlameExtent, furthestPawnDist);
        // End:0x643
        if(ImpactInfoArray.Length > 0)
        {
            // End:0x642
            foreach VisibleCollidingActors(class'FoxPawn', aPawn, furthestPawnDist + float(300), StartTrace,,,,, HitInfo)
            {
                // End:0x641
                if(aPawn != Instigator)
                {
                    I = 0;
                    J0x21E:
                    // End:0x641 [Loop If]
                    if(I < ImpactInfoArray.Length)
                    {
                        // End:0x633
                        if(ImpactInfoArray[I].HitPawn == aPawn)
                        {
                            aPawn.TakeDamage(int(((FlameExtent - ImpactInfoArray[I].PawnDistanceFromTrace) / FlameExtent) * (GetFireModeDamage(0, ImpactInfoArray[I].HitPawn.Location, ImpactInfoArray[I].HitPawn))), Instigator.Controller, vect(0.0, 0.0, 0.0), vect(0.0, 0.0, 0.0), InstantHitDamageTypes[0], HitInfo, self);
                            // End:0x532
                            if(((((Instigator != none) && Instigator.PlayerReplicationInfo != none) && aPawn != none) && aPawn.PlayerReplicationInfo != none) && !aPawn.PlayerReplicationInfo.OnSameTeamAsPRI(Instigator.PlayerReplicationInfo))
                            {
                                // End:0x532
                                if((FoxPRI(Instigator.PlayerReplicationInfo) != none) && FoxPRI(Instigator.PlayerReplicationInfo).WeaponUsageStats != none)
                                {
                                    FoxPRI(Instigator.PlayerReplicationInfo).WeaponUsageStats.IncrementRoundsHit(FoxPawn(Instigator).CurrentZoomState);
                                }
                            }
                            FlashLoc.Location = aPawn.Mesh.GetBoneLocation(aPawn.FlameImpactBoneName);
                            // End:0x60A
                            if(WorldInfo.GRI.bClientSideHitDetection)
                            {
                                FoxPawn(Instigator).ClientSetFlashLocation(FlashLoc);
                            }
                            SetFlashLocation(FlashLoc.Location);
                            // End:0x641
                            continue;
                        }
                        ++ I;
                        // [Loop Continue]
                        goto J0x21E;
                    }
                }                
            }            
        }
    }
    //return;    
}

simulated function Rotator AddSpread(const Rotator BaseAim)
{
    return BaseAim;
    //return ReturnValue;    
}

simulated function PropagateSeed(const int Seed)
{
    //return;    
}

simulated state WeaponFiring
{
    simulated event BeginState(name PreviousStateName)
    {
        super.BeginState(PreviousStateName);
        // End:0x98
        if((FoxPawn(Instigator) != none) && FoxPC(Instigator.Controller) != none)
        {
            FoxPC(Instigator.Controller).NotifyWeaponTriggerPulledState(true);
        }
        //return;        
    }

    simulated event EndState(name NextStateName)
    {
        super.EndState(NextStateName);
        // End:0x98
        if((FoxPawn(Instigator) != none) && FoxPC(Instigator.Controller) != none)
        {
            FoxPC(Instigator.Controller).NotifyWeaponTriggerPulledState(false);
        }
        //return;        
    }
    stop;    
}

defaultproperties
{
    FlameExtent=50.0
    ActionSocketName=S_Action
    bIsDepotWeapon=true
    bCanMelee=false
    bSupportsMuzzleMods=false
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_FlameThrowerBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_FlameThrowerBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_FlameThrowerBase.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_FlameThrowerBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.72704240
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_FlameThrowerBase.LensComp'
    MuzzleLensFlare=LensComp
    WeaponFireTypes=/* Array type was not detected. */
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_FlameThrowerBase.WeaponMesh'
    Mesh=WeaponMesh
}